

import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from '../../../core/global';

@Component({
    selector: 'snpr027',
    templateUrl: './SNPR027.component.html',
    styleUrls: ['./SNPR027.component.css']
})

export class SNPR027Component implements OnInit {


    constructor(
      private HttpService: HttpService,
      private modal: ModalService,
      private viewref: ViewContainerRef,
      private route: ActivatedRoute,
      private global: Globals
    ) { }
    
    //@ViewChild('fileUpload') myInputVariable: ElementRef;

  @Input() config: any;
  @Input() data: any;
  @Output() datacallback = new EventEmitter<string>();


  public dataListDialogInvoiceDate: any = [];
  public findingWord: string;

  public ConfigDocNo: any = {
    ColName: "DOCUMENT_NO",
    ColValue: "DOCUMENT_NO",
    PlaceholderText: "Select Document No",
    SourceController: "AC",
    SourceMethodName: "SNPR027_DocNo_Find",
    NoOfShowRecords: 100,
    MinLengthSearch: 2,
    UpperCase: true
  }

  public ConfigDocType: any = {
    ColName: "DOCUMENT_TYPE",
    ColValue: "DOCUMENT_TYPE",
    PlaceholderText: "Select Document Type",
    SourceController: "AC",
    SourceMethodName: "SNPR027_DocType_Find",
    NoOfShowRecords: 100,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public dataListSeqByInvoiceDate: any =[];

  public ListDataReportCondition: any = {
      DOCUMENT_TYPE_FROM : null,
      DOCUMENT_TYPE_TO : null,
      DOCUMENT_NO_FROM : null,
      DOCUMENT_NO_TO : null,
  };

  ngOnInit() {
  }

  OpenReport(){

      if(!this.CheckSearchCondition()){
        this.GoToReport();//show roport viewer.
      }
  }

  

  CheckSearchCondition() {
    console.log('this.ListDataReportCondition.DOCUMENT_TYPE_FROM 1 : ', this.ListDataReportCondition.DOCUMENT_TYPE_FROM);

    let boolHadSelectedCondition: boolean;
    boolHadSelectedCondition = false;//maening: User is not selecting condition search report.

    console.log('this.ListDataReportCondition.DOCUMENT_TYPE_FROM 2: ', this.ListDataReportCondition.DOCUMENT_TYPE_FROM);

    if (!this.ListDataReportCondition.DOCUMENT_TYPE_FROM) { this.ListDataReportCondition.DOCUMENT_TYPE_FROM = null; }
    if (!this.ListDataReportCondition.DOCUMENT_TYPE_TO) { this.ListDataReportCondition.DOCUMENT_TYPE_TO = null; }

    console.log('this.ListDataReportCondition.DOCUMENT_TYPE_FROM 3: ', this.ListDataReportCondition.DOCUMENT_TYPE_FROM);

    if (!this.ListDataReportCondition.DOCUMENT_NO_FROM) { this.ListDataReportCondition.DOCUMENT_NO_FROM = null; }
    if (!this.ListDataReportCondition.DOCUMENT_NO_TO) { this.ListDataReportCondition.DOCUMENT_NO_TO = null; }
    
    //console.log("When clear emply string:",this.ListDataReportCondition);

    //check From and To condition when user select only from or only to. must put value to it.


    if (this.ListDataReportCondition.DOCUMENT_NO_FROM == null) {
      this.ListDataReportCondition.DOCUMENT_NO_FROM = this.ListDataReportCondition.DOCUMENT_NO_TO;

      boolHadSelectedCondition = true;
    }
    if (this.ListDataReportCondition.DOCUMENT_NO_TO == null) {
      this.ListDataReportCondition.DOCUMENT_NO_TO = this.ListDataReportCondition.DOCUMENT_NO_FROM;
      boolHadSelectedCondition = true;
    }

    if (this.ListDataReportCondition.DOCUMENT_TYPE_FROM == null) {
      this.ListDataReportCondition.DOCUMENT_TYPE_FROM = this.ListDataReportCondition.DOCUMENT_TYPE_TO;
      if (this.ListDataReportCondition.DOCUMENT_TYPE_FROM == null) {
        this.ListDataReportCondition.DOCUMENT_TYPE_FROM = this.ListDataReportCondition.DOCUMENT_NO_FROM.substr(0, 2); 
      }      
      boolHadSelectedCondition = false;
    }
    if (this.ListDataReportCondition.DOCUMENT_TYPE_TO == null) {
      this.ListDataReportCondition.DOCUMENT_TYPE_TO = this.ListDataReportCondition.DOCUMENT_TYPE_FROM;
      if (this.ListDataReportCondition.DOCUMENT_TYPE_TO == null) {
        this.ListDataReportCondition.DOCUMENT_TYPE_TO = this.ListDataReportCondition.DOCUMENT_NO_TO.substr(0, 2);
      }     
      boolHadSelectedCondition = false;
    }
    
    return boolHadSelectedCondition;
  }

  GoToReport() {
    console.log('this.ListDataReportCondition.DOCUMENT_TYPE_FROM : ', this.ListDataReportCondition.DOCUMENT_TYPE_FROM);
    this.global.GoToReport("PMS_RPT_ACC_SNPR027A",
      {
        P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
        P_DOCUMENT_TYPE_FROM: this.ListDataReportCondition.DOCUMENT_TYPE_FROM, 
        P_DOCUMENT_TYPE_TO: this.ListDataReportCondition.DOCUMENT_TYPE_TO, 
        P_DOCUMENT_NO_FROM: this.ListDataReportCondition.DOCUMENT_NO_FROM, 
        P_DOCUMENT_NO_TO: this.ListDataReportCondition.DOCUMENT_NO_TO })
  }

  public FindSeqByInvoiceDate(strInvoiceDate:any){
     
  }

}

