import { Component, OnInit, ViewChild, ViewContainerRef, ViewChildren } from "@angular/core";
import { HttpService } from '../../../core/http.service';
import { Router } from '@angular/router';
import { AuthDecode } from 'src/app/core/auth-decode.service';
import { ModalService } from 'src/app/core/modal.service';
import { async } from '@angular/core/testing';
import { Globals } from 'src/app/core/global';


@Component({
  selector: 'snse069m',
  templateUrl: 'SNSE069_M.component.html',
  styleUrls: ['SNSE069_M.component.css']
})

export class SNSE069_MComponent implements OnInit {

  constructor(
    private http: HttpService,
    private auth: AuthDecode,
    private modal: ModalService,
    private router: Router,
    private viewref: ViewContainerRef,
    private global: Globals
  ) { }
    @ViewChild("dialog", { static: false }) dialog: any;
    @ViewChild("dialogPartQty", { static: false }) dialogPartQty: any;
    @ViewChild("dialogSummary", { static: false }) dialogSummary: any;
    @ViewChildren("input") Inputs : any;

  public CustomerList: any;
  private loaded: boolean = false;
  public data: any = {
    AMT_A: null,
    QTY_A: null,
    ITEM_A: null,
    AMT_M: null,
    QTY_M: null,
    ITEM_M: null,
    AMT_ALL: null,
    QTY_ALL: null,
    ITEM_ALL: null,
    CREATE_BY: null,
    CREATE_DATE: null,
    LAST_UPD_PGM: null,
    LAST_UPD_BY: null,
    LAST_UPD_DATE: null,
    LAST_IP_ADDR: null,
    LAST_UPD_NAME: null,
  };
  public tableData: any;
  public tableDataPart: any;
  public tableName: string;
  public SData: any = {
    SEQ_NO_FROM: null,
    SEQ_NO_TO: null,
    MAX_VALUE: null
  };
  public Frm: any;
  private fileList : any = [];
  ngOnInit() {
    this.InitData();
  }
  InitData() {
    this.SData.MAX_VALUE = 500;
    this.data = {};
    this.data.CREATE_DATE = new Date();
    this.data.LAST_UPD_DATE = new Date();
    this.data.LAST_UPD_NAME = this.global.GetTokenDetail("ssNameEN");
  }
  openDialog(frm) {
    this.tableData = [];
    this.http.get("AC", "SNSE069M_Get_Stock_Taking")
      .subscribe(result => {
        this.tableData = result.Table;
        if (this.Frm === "F") {
          this.dialog.title = "Customer";
        }
        else if (this.Frm === "T") {
          this.dialog.title = "Order";
        }
        this.dialog.OpenDialog()
      });
    this.Frm = frm;
  }
  Select_From(event) {
    if (this.Frm === "F") {
      this.SData.SEQ_NO_FROM = event.SEQ_NO
    } else if (this.Frm === "T") {
      this.SData.SEQ_NO_TO = event.SEQ_NO
    }

    this.dialog.Close();
  }
  EntryCheckQty() {
    if (this.SData.SEQ_NO_FROM === null || this.SData.SEQ_NO_TO === null) {
      this.CheckUnselectMinMax();
    } else {
      if (this.SData.SEQ_NO_FROM > this.SData.SEQ_NO_TO) {
        this.modal.warning("ค่า Seq. To ต้องมากกว่าหรือเท่ากับค่า Seq. From", this.viewref);
        return;
      }
      this.GetGrdPartQty();
    }
  }
  GetGrdPartQty() {
    this.http.get("AC", "SNSE069M_Get_Part_Qty", this.SData.SEQ_NO_FROM, this.SData.SEQ_NO_TO, this.SData.MAX_VALUE)
      .subscribe(result => {
        this.tableDataPart = result.Table;
        this.dialogPartQty.title = "Check Part Qty";
        this.dialogPartQty.OpenDialog();
      });
  }
  ShowSummary() {
    this.getLastMinMax();
    this.http.get("AC", "SNSE069M_Get_Summary")
      .subscribe(result => {
       
        if (result.Table != null) {
          if (this.global.GetTokenDetail("ssComCode") === '01') {
            this.dialogSummary.title = "SNA";
           
          } else if (this.global.GetTokenDetail("ssComCode") === '03') {
            this.dialogSummary.title = "SMNS";
            
          } else {
            this.dialogSummary.title = "SNA&SMNS";
           
          }
        
          this.data.AMT_A = result.Table[0].AMT;
          this.data.QTY_A = result.Table[0].QTY;
          this.data.ITEM_A = result.Table[0].ITEM;
          this.data.AMT_M = result.Table[1].AMT;
          this.data.QTY_M = result.Table[1].QTY;
          this.data.ITEM_M = result.Table[1].ITEM;
          this.data.AMT_ALL = result.Table[2].AMT;
          this.data.QTY_ALL = result.Table[2].QTY;
          this.data.ITEM_ALL = result.Table[2].ITEM;
         
        }
        this.dialogSummary.OpenDialog();
      });

    
  }
  getLastMinMax() {
    this.http.get("AC", "SNSE069M_Get_Seq")
      .subscribe(result => {
        if (this.SData.SEQ_NO_FROM === null) {
          this.SData.SEQ_NO_FROM = result.Table[0].SEQ_FROM;
        }
        if (this.SData.SEQ_NO_TO === null) {
          this.SData.SEQ_NO_TO = result.Table1[0].SEQ_TO;
        }
      });
  }

  CheckUnselectMinMax() {
  
      this.http.get("AC", "SNSE069M_Get_Seq")
        .subscribe(result => {
          if (this.SData.SEQ_NO_FROM === null) {
            this.SData.SEQ_NO_FROM = result.Table[0].SEQ_FROM;
          }
          if (this.SData.SEQ_NO_TO === null) {
            this.SData.SEQ_NO_TO = result.Table1[0].SEQ_TO;
          }
          this.GetGrdPartQty();
        });
  }
  SaveAdd() {

    let forsave = this.tableDataPart.filter(x => x.O_CHK_QTY != x.CHECK_QTY)
    
    if(forsave.length > 0 ){
      this.modal.confirm("Do you want to save change you have made?",this.viewref,() =>{
        this.http.post("AC", "SNSE069M_Save_Part_QTY", forsave)
        .subscribe(result => {
          // console.log(result)
          if (result.Table[0].STATUS == 'DONE') {
            this.dialogPartQty.Close();
            this.modal.info('Transaction complete: '+ forsave.length + ' record applied and saved.', this.viewref);
          } else {
            this.modal.warning('No change to save. Found duplicate record.', this.viewref);
          }
        },(err) => {
            this.modal.error(err.message,this.viewref);
        });
    })
    }else{
      this.modal.warning("No data change",this.viewref);
    }
  }

  CancelAdd() {
    this.dialogPartQty.Close();
  }


  focusInput(rowIdx: number) {
    
    let inputEls = this.Inputs.toArray();
    inputEls[rowIdx].nativeElement.focus();
  }

  shiftFocusDown(rowIdx:number) {
    rowIdx = Math.min(rowIdx + 1, this.tableDataPart.length - 1);
    this.focusInput(rowIdx);
  }

  shiftFocusUp(rowIdx:number) {
    rowIdx = Math.max(0, rowIdx - 1);
    this.focusInput(rowIdx);
  }



  async Export(p_rpt) {
    
    this.http.get("AC", "SNSE069M_Get_Seq")
      .subscribe(result => {
        if (this.SData.SEQ_NO_FROM === null) {
          this.SData.SEQ_NO_FROM = result.Table[0].SEQ_FROM;
        }
        if (this.SData.SEQ_NO_TO === null) {
          this.SData.SEQ_NO_TO = result.Table1[0].SEQ_TO;
        }
        if (p_rpt === "BYLOC1") {
          this.fileList = [];
          this.http.get("AC", "SNSE069M_Get_022_LOC", this.SData.SEQ_NO_FROM, this.SData.SEQ_NO_TO)
            .subscribe(result => {
              let index = 0;     
              let data = result.Table
              for (var item of data) {

                let location = item["LOCATION_NO"]
                if(!item["LOCATION_NO"]){
                    location = "ALL"
                }
    

                let fileName1 = "SNSR022" + "_" + location + '_' + this.FormatDate() + "." + "PDF";
                let fileName2 = "SNSR023" + "_" + location + '_' + this.FormatDate() + "." + "PDF"

                let reportParams = {
                  P_COMPANY_CODE : this.global.GetTokenDetail("ssComCode"),
                  P_SEQ_NO_FROM : this.SData.SEQ_NO_FROM,
                  P_SEQ_NO_TO : this.SData.SEQ_NO_TO,
                  P_LOCATION_NO : location,
                  P_FORM_ID: 'SNSE069_M'
              }

              this.http.getParams("AC", ["SNSE069_M_GenerateReport","PMS_RPT_ACC_SNSR022_M","PMS_RPT_ACC_SNSR023_M",fileName1,fileName2], reportParams)
              .subscribe(res => {
                  this.fileList.push({
                      file_path : res.substring(1),
                      file_name : fileName1
                  })

                  this.fileList.push({
                      file_path : res.substring(1),
                      file_name : fileName2
                  })
                      index++
                  if(index ==  data.length){
                      //console.log(this.fileList)
                      this.DownLoad();
                  }
               })
              }
            });
        } else if (p_rpt === "BYLOC2") {
          this.SData.SEQ_NO_FROM = result.Table[0].SEQ_FROM;
          this.SData.SEQ_NO_TO = result.Table1[0].SEQ_TO;
          this.http.get("AC", "SNSE069M_Get_022_LOC", this.SData.SEQ_NO_FROM, this.SData.SEQ_NO_TO)
            .subscribe(result => {
              let index = 0;     
              let data = result.Table
              for (var item of data) {

                let location = item["LOCATION_NO"]
                if(!item["LOCATION_NO"]){
                    location = "ALL"
                }
    

                let fileName1 = "SNSR022" + "_" + location + '_' + this.FormatDate() + "." + "PDF";
                let fileName2 = "SNSR023" + "_" + location + '_' + this.FormatDate() + "." + "PDF"

                let reportParams = {
                  P_COMPANY_CODE : this.global.GetTokenDetail("ssComCode"),
                  P_SEQ_NO_FROM : this.SData.SEQ_NO_FROM,
                  P_SEQ_NO_TO : this.SData.SEQ_NO_TO,
                  P_LOCATION_NO : location,
                  P_FORM_ID: 'SNSE069_M'
              }

              this.http.getParams("AC", ["SNSE069_M_GenerateReport","PMS_RPT_ACC_SNSR022_M","PMS_RPT_ACC_SNSR023_M",fileName1,fileName2], reportParams)
              .subscribe(res => {
                  this.fileList.push({
                      file_path : res.substring(1),
                      file_name : fileName1
                  })

                  this.fileList.push({
                      file_path : res.substring(1),
                      file_name : fileName2
                  })
                      index++
                  if(index ==  data.length){
                      //console.log(this.fileList)
                      this.DownLoad();
                  }
               })
              }
            });
        } else if (p_rpt === "BYLOC3") {
          this.global.GoToReport("PMS_RPT_AC_SNSR025_M",
            {
              P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
              P_SEQ_NO_FROM: this.SData.SEQ_NO_FROM,
              P_SEQ_NO_TO: this.SData.SEQ_NO_TO
            });
          this.global.GoToReport("PMS_RPT_AC_SNSR035_M",
            {
              P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
              P_SEQ_NO_FROM: this.SData.SEQ_NO_FROM,
              P_SEQ_NO_TO: this.SData.SEQ_NO_TO
            });
        } else if (p_rpt === "BYLOC4") {
          this.global.GoToReport("PMS_RPT_AC_SNSR026_M",
            {
              P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
              P_SEQ_NO_FROM: this.SData.SEQ_NO_FROM,
              P_SEQ_NO_TO: this.SData.SEQ_NO_TO
            });
          this.global.GoToReport("PMS_RPT_AC_SNSR036_M",
            {
              P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
              P_SEQ_NO_FROM: this.SData.SEQ_NO_FROM,
              P_SEQ_NO_TO: this.SData.SEQ_NO_TO
            });

        } else if (p_rpt === "BYLOC5") {
          this.global.GoToReport("PMS_RPT_AC_SNSR024_M",
            {
              P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
              P_SEQ_NO_FROM: this.SData.SEQ_NO_FROM,
              P_SEQ_NO_TO: this.SData.SEQ_NO_TO
            });
          this.global.GoToReport("PMS_RPT_AC_SNSR034_M",
            {
              P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
              P_SEQ_NO_FROM: this.SData.SEQ_NO_FROM,
              P_SEQ_NO_TO: this.SData.SEQ_NO_TO
            });

        }else {
          this.global.GoToReport(p_rpt,
            {
              P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
              P_SEQ_NO_FROM: this.SData.SEQ_NO_FROM,
              P_SEQ_NO_TO: this.SData.SEQ_NO_TO
            }
          );
        }
      });
  }

  DownLoad(){
    this.http.DownloadMultipleFilesAsZip("AC","SNSE069_M_DowLoad",this.fileList)
    .subscribe(res =>{
        //this.modal.info("Process Complete !.......",this.viewref)
        this.WriteFile(res);
    })
  }


  WriteFile(res){
      var blob = new Blob([res], { type: "application/octet-stream" });                
      var fileURL = URL.createObjectURL(blob);
      var a = document.createElement('a');
      a.href = fileURL;
      a.target = '_blank';
      a.download = "SNSE069_M.zip";
      document.body.appendChild(a);
      a.click();
      document.body.removeChild(a);
  }

  FormatDate() {

    let d = new Date();
    let Day = d.getDate().toString();
    let Month = d.getMonth() + 1;
    let NewMonth = Month.toString().length < 2 ? '0' + Month.toString() : Month.toString()
    let Year = d.getFullYear().toString();
    let hours = d.getHours();
    let minute = d.getMinutes();
    let second = d.getSeconds();

    return  Day + '-' + NewMonth + '-' + Year + '_' + hours + '-' + minute + '-' + second;
  }



}
