import { Component, OnInit, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { ModalService } from 'src/app/core/modal.service';
import * as moment from 'moment';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'dailyrep',
  templateUrl: './DAILYREP.component.html',
  styleUrls: ['./DAILYREP.component.css']
})

export class DAILYREPComponent implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private global: Globals
  ) { }

  public currentDate: moment.Moment;
  public countRow: number;

  ngOnInit() {
    this.currentDate = moment();
    // this.GetCurrentDate();
  }

  GetCurrentDate() {
    this.http.GetSystemDate()
      .subscribe(d => {
        this.currentDate = moment(d);
      })
  }

  RunReport() {
    let currentDate = this.global.ConvertDateToFormatSTD(this.currentDate);

    this.http.getParams("AC", ["DAILYREP", currentDate], null)
      .subscribe(result => {
        this.modal.info("Generate Daily reports completed."
          , this.viewref);
      })
  }

}

