import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'snpj006_d0',
  templateUrl: './snpj006_d0.component.html',
  styleUrls: ['./snpj006_d0.component.css']
})



export class SNPJ006_D0Component implements OnInit {

  public fileConfig: any = {
    PlaceholderText: 'Current Text Data',
    AcceptFileType: '*',
    MultipleSelect: true
  }

  public PATH1: string;
  public PATH2: string;

  public files: string[];
  public formName: any;

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) { 

  }

  public data: any;
  ngOnInit() {
    this.GetFilePath();
  }

  GetFilePath() {
    this.http.get("IC", "SNPJ006_D0_GetFilePath")
      .subscribe(result => {
        this.PATH1 = result.Table[0]["FM_FILE_NAME"];
        this.PATH2 = result.Table[0]["TO_FILE_NAME"];
      })
  }

  FileSelected(files: any) {
    this.files = Array.prototype.map.call(files, v => v);
  }

  SaveFiles() {
    this.modal.confirm("Are you sure to save files?", this.viewref,
      () => {
        let formData: FormData = new FormData();
        this.files.forEach((f: any) => {
          formData.append('file', f, f.name)
        })

        this.http.postFile("IC", "SNPJ006_D0_SaveFile", formData)
          .subscribe(result => {
            this.modal.info(result, this.viewref);
            this.files = null;
          }, (err) => {
            this.modal.error(err.error, this.viewref);
          })
      }, () => { })
  }

}
