import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { MatTableDataSource } from '@angular/material/table';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';


@Component({
  selector: 'snpe019',
  templateUrl: './snpe019.component.html',
  styleUrls: ['./snpe019.component.css']
})



export class SNPE019Component implements OnInit {

  @ContentChild(TemplateRef, { static: false }) templateRef;
  @ViewChild(MatPaginator, { static: true }) paginator: MatPaginator;
  @ViewChild(MatSort, { static: true }) sort: MatSort;

  constructor(
    private http: HttpService,
    private router: Router
  ) { }


  public headerList: any;
  public data: any;
  public dataList: any;
  public displayedColumns: string[] = [];
  public isCustomContent: boolean = false;
  public SelectList: any;

  ngOnInit() {

    this.SelectList = [{ ID: 1, SELECT_CODE: "A001" }, { ID: 2, SELECT_CODE: "B002" }, { ID: 3, SELECT_CODE: "C003" }]


    this.headerList = [{ FIELD_NAME: "PARTNO", TITLE: "Part No." },
      { FIELD_NAME: "PARTNAME", TITLE: "Part Name " },
      { FIELD_NAME: "QTY", TITLE: "Qty" },
      { FIELD_NAME: "PRICE", TITLE: "Price" },
      { FIELD_NAME: "RETAILPRICE", TITLE: "Retail Price" },
      { FIELD_NAME: "AMOUNT", TITLE: "Amount" }];

    this.data = [{
      PARTNAME: '1',
      QTY: '1',
      PRICE: '1',
      RETAILPRICE: '1',
      AMOUNT: '1',
    },
    {
      PARTNAME: '2',
      QTY: '2',
      PRICE: '2',
      RETAILPRICE: '2',
      AMOUNT: '2',
    },
    {
      PARTNAME: '3',
      QTY: '3',
      PRICE: '3',
      RETAILPRICE: '3',
      AMOUNT: '3',
    }
    ]

    this.dataList = new MatTableDataSource<any>(this.data);
    this.displayedColumns = this.headerList.map(v => v.FIELD_NAME);

  }


  ngAfterContentInit(): void {
    if (this.templateRef) {
      this.isCustomContent = true;
    }
  }

}
