import { Component, OnInit, ViewContainerRef } from '@angular/core'
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import * as moment from 'moment';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'snse033N',
  templateUrl: './SNSE033N.component.html',
  styleUrls: ['./SNSE033N.component.css']
})

export class SNSE033NComponent implements OnInit {

  constructor(
    private http: HttpService,
    private modal: ModalService,
    private viewRef: ViewContainerRef,
    private global: Globals,
    private router: Router
  ) { }


  public tableDataAir: any = [];
  public tableDataSea: any = [];
  public CustomerList: any = {};
  public paramAir: any = {};
  public paramSea: any = {};

  public dataAir: any = {};
  public dataSea: any = {};
  public dataSet: any = {};

  public tblFooter: any = [
    {
      fieldName: "PACK_BY",
      value: "Total",
      show: true
    },
    {
      fieldName: "GROSS_WEIGHT",
  
      show: true
    },
    {
      fieldName: "GROSS_MM",

      show: true
    },
    {
      fieldName: "PACK_QTY",
   
      show: true
    },
    {
      fieldName: "AMOUNT",

      show: true
    }

  ]

  public lookupCustomerCodeAir: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE033_GetCustomerCodeAir",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }


  public lookupPreInvoiceAir: any = {
    ColName: "PINVOICE_TEXT",
    PlaceholderText: "Select Pre-invoice no.",
    SourceController: "SL",
    SourceMethodName: "SNSE033_GetPreInvoiceAir",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: "",
      BRANCH_CODE: "01"
    }
  }

  public lookupCustomerCodeSea: any = {
    ColName: "LOOKUP_CUSTOMER_CODE",
    PlaceholderText: "Select Customer Code",
    SourceController: "SL",
    SourceMethodName: "SNSE033_GetCustomerCodeSea",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }


  public lookupPreInvoiceSea: any = {
    ColName: "PINVOICE_TEXT",
    PlaceholderText: "Select Pre-invoice no.",
    SourceController: "SL",
    SourceMethodName: "SNSE033_GetPreInvoiceSea",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true,
    SourceParams: {
      CUSTOMER_CODE: "",
      BRANCH_CODE: ""
    }
  }

  ngOnInit() {
    this.paramAir.ATTACH_SHEET = 'Y';
    this.paramSea.ATTACH_SHEET = 'Y';

  }



  public SetSelectedCustomerCode(values: any, pSendBy: any) {

    if (pSendBy == 'A') {
      this.paramAir.CUSTOMER_CODE = values.CUSTOMER_CODE;
      this.paramAir.CUSTOMER_NAME = values.CUSTOMER_NAME;
      this.paramAir.BRANCH_CODE = values.BRANCH_CODE;
      this.paramAir.BRANCH_NAME = values.BRANCH_NAME;
      this.paramAir.COUNTRY = values.COUNTRY;
      this.paramAir.CURRENCY_CODE = values.CURRENCY_CODE;
      this.paramAir.PAYMENT_TERM = values.PAYMENT_TERM;
      this.paramAir.EXCHANGE_RATE = values.EXCHANGE_RATE;

      this.lookupPreInvoiceAir.SourceParams.CUSTOMER_CODE = values.CUSTOMER_CODE;
      this.lookupPreInvoiceAir.SourceParams.BRANCH_CODE = values.BRANCH_CODE;


      this.paramAir.PINVOICE_NO = '';
      this.paramAir.PINVOICE_DATE = '';
      this.tableDataAir = [];
    } else {

      this.paramSea.CUSTOMER_CODE = values.CUSTOMER_CODE;
      this.paramSea.CUSTOMER_NAME = values.CUSTOMER_NAME;
      this.paramSea.BRANCH_CODE = values.BRANCH_CODE;
      this.paramSea.BRANCH_NAME = values.BRANCH_NAME;
      this.paramSea.COUNTRY = values.COUNTRY;
      this.paramSea.CURRENCY_CODE = values.CURRENCY_CODE;
      this.paramSea.PAYMENT_TERM = values.PAYMENT_TERM;
      this.paramSea.EXCHANGE_RATE = values.EXCHANGE_RATE;

      this.lookupPreInvoiceSea.SourceParams.CUSTOMER_CODE = values.CUSTOMER_CODE;
      this.lookupPreInvoiceSea.SourceParams.BRANCH_CODE = values.BRANCH_CODE;


      this.paramSea.PINVOICE_NO = '';
      this.paramSea.PINVOICE_DATE = '';
      this.tableDataSea = [];
    }

  }


  public SelectPreInvoice(values: any, pSendBy: any) {

    if (pSendBy == 'A') {
      this.paramAir.PINVOICE_NO = values.PINVOICE_NO;
      this.paramAir.PINVOICE_DATE = values.PINVOICE_DATE;
      this.paramAir.DOC_TYPE = values.DOC_TYPE;
    } else {
      this.paramSea.PINVOICE_NO = values.PINVOICE_NO;
      this.paramSea.PINVOICE_DATE = values.PINVOICE_DATE;
      this.paramSea.DOC_TYPE = values.DOC_TYPE;
    }

    this.GetData(pSendBy);
  }


  private GetData(pSendBy: any) {

    if (pSendBy == 'A') {
      this.tableDataAir = [];
      //console.log('SNSE033_GetDataAir');
      this.http.post('SL', 'SNSE033_GetDataAir', this.paramAir)
        .subscribe(res => {
          this.tableDataAir = res.Table1;
          //console.log('res.Table1', res.Table1);
        })
    } else {
      this.tableDataSea = [];

      this.http.post('SL', 'SNSE033_GetDataSea', this.paramSea)
        .subscribe(res => {
          this.tableDataSea = res.Table1;
        })

    }

  }

  CheckToPack(evt, data) { }


  public Confirm_Click(pSendBy: any) {

    var msg: any = '';

    if (pSendBy == 'A') {


      if (this.paramAir.EXCHANGE_RATE == '') {
        msg = "Exchange Rate Invalid." + '<br/>';
      }

      //console.log('this.dataAir.FLIGHT_NO', this.dataAir.FLIGHT_NO);

      if (this.dataAir.FLIGHT_NO == '' || this.dataAir.FLIGHT_NO == undefined) {
        msg = msg + "Flight No. is not input.." + "<br/>";
      }
      if (this.dataAir.AWB_NO == '' || this.dataAir.AWB_NO == undefined) {
        msg = msg + "AWB No. is not input.." + "<br/>";
      }

      var dToDate = moment().locale("en");
      if (this.dataAir.AWB_DATE == '' || this.dataAir.AWB_DATE == undefined) {
        msg = msg + "AWB Date. is not input.." + "<br/>";
      } else if (this.dataAir.AWB_DATE < dToDate) {
        this.modal.warning("", this.viewRef);
        msg = msg + "AWB Date. is lower than current date" + "<br/>";
      }

      if (msg != '') {
        this.modal.warning(msg, this.viewRef);
        return;
      }

      var dataSelected = this.tableDataAir.filter(v => v.SELECT_CONFIRM === true);
      var nCT = 0;

      // console.log('dataSelected.length ', dataSelected.length);

      if (dataSelected.length == 0) {
        this.modal.warning('No "Case No." to be selected. Please check', this.viewRef);
        return;
      }

      dataSelected.forEach((value) => {
        if (value.CONTAINER_NO == '') {
          nCT = nCT + 1;
        }
      });

      if (nCT != 0) {
        this.modal.warning('Container No. Invalid.', this.viewRef);
        return;
      }
      dataSelected[0].AWB_NO = this.dataAir.AWB_NO;
      dataSelected[0].AWB_DATE = this.dataAir.AWB_DATE;
      dataSelected[0].FRC = this.dataAir.FRC;
      dataSelected[0].FWC = this.dataAir.FWC;
      dataSelected[0].INS = this.dataAir.INS;
      dataSelected[0].FLIGHT_NO = this.dataAir.FLIGHT_NO;
      dataSelected[0].TOTAL_CASE = dataSelected.length;
      //console.log('dataSelected[0] : ', dataSelected[0]);

      this.http.post('SL', 'SNSE033_ConfirmAir', dataSelected)
        .subscribe(result => {
          if (result.substring(0, 4) == "DONE") {
            this.GetData(pSendBy);
            this.dataAir.INVOICE_NO = result.substring(6, 20);
            this.modal.info("Confirm successfully [Invoice no.] : " + result.substring(6, 20), this.viewRef);

            this.dataAir.AWB_NO = '';
            this.dataAir.AWB_DATE = '';
            this.dataAir.FRC = '';
            this.dataAir.FWC = '';
            this.dataAir.INS = '';
            this.dataAir.FLIGHT_NO = '';

            if (this.paramAir.ATTACH_SHEET == 'Y') {
              this.OpenReport(this.paramAir.DOC_TYPE, this.paramAir.PINVOICE_NO)
            }
          } else {
            this.GetData(pSendBy);
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          }
        }, (err) => {
          this.GetData(pSendBy);
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })


    } else { //------------- Sea
      msg = '';
      if (this.dataSea.VESSEL == '') {
        msg = msg + "Vessel is not input.." + "<br/>";
      }
      if (this.dataSea.BL_NO == '') {
        msg = msg + "B/L No. is not input.." + "<br/>";
      }
      if (this.dataSea.BL_DATE == '') {
        msg = msg + "B/L Date is not input.."+ "<br/>";
      }
      //---- Compare date
      var dToDate = moment().locale("en");
      if (this.dataSea.BL_DATE < dToDate) {
        msg = msg + "B/L Date is lower than current date" + "<br/>";
      }

      if (msg != '') {
        this.modal.warning(msg, this.viewRef);
        return;
      }

      var dataSelected = this.tableDataSea.filter(v => v.SELECT_CONFIRM == true);
      var nCT = 0;

      if (dataSelected.length == 0) {
        this.modal.warning('No "Case No." to be selected. Please check', this.viewRef);
        return;
      }

      dataSelected.forEach((value) => {
        if (value.CONTAINER_NO == '') {
          nCT = nCT + 1;
        }
      });

      if (nCT != 0) {
        this.modal.warning('Container No. Invalid.', this.viewRef);
        return;
      }
      dataSelected[0].BL_NO = this.dataSea.BL_NO;
      dataSelected[0].BL_DATE = this.dataSea.BL_DATE;
      console.log('this.dataSea.BL_DATE', this.dataSea.BL_DATE);
      dataSelected[0].FRC = this.dataSea.FRC;
      dataSelected[0].FWC = this.dataSea.FWC;
      dataSelected[0].INS = this.dataSea.INS;
      dataSelected[0].VESSEL = this.dataSea.VESSEL;
      dataSelected[0].TOTAL_CASE = dataSelected.length;
      //console.log('dataSelected[0] : ', dataSelected[0]);

      this.http.post('SL', 'SNSE033_ConfirmSea', dataSelected)
        .subscribe(result => {
          if (result.substring(0, 4) == "DONE") {
            this.GetData(pSendBy);
            this.dataSea.INVOICE_NO = result.substring(6, 20);
            this.modal.info("Confirm successfully [Invoice no.] : " + result.substring(6, 20), this.viewRef);
            this.dataSea.BL_NO = '';
            this.dataSea.BL_DATE = '';
            this.dataSea.FRC = '';
            this.dataSea.FWC = '';
            this.dataSea.INS = '';
            this.dataSea.VESSEL = '';
            if (this.paramSea.ATTACH_SHEET == 'Y') {
              this.OpenReport(this.paramSea.DOC_TYPE, this.paramSea.PINVOICE_NO)
            }
          } else {
            this.GetData(pSendBy);
            this.modal.warning("Found an error, please contract support team", this.viewRef);
          }
        }, (err) => {
          this.GetData(pSendBy);
          console.log(err, 'err')
          this.modal.warning("Found an error, please contract support team", this.viewRef);
        })

    }


  }

  public CheckPrintChangeAir(value) {
    if (value.checked == true) {
      this.paramAir.ATTACH_SHEET = 'Y'
    }
    else {
      this.paramAir.ATTACH_SHEET = 'N'
    }
  }

  public CheckPrintChangeSea(value) {
    if (value.checked == true) {
      this.paramSea.ATTACH_SHEET = 'Y'
    }
    else {
      this.paramSea.ATTACH_SHEET = 'N'
    }
  }


  private OpenReport(docType, docNo) {
    this.global.GoToReport("PMS_RPT_SALES_SNSE033R_N", {
      P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"),
      P_DOC_TYPE: docType,
      P_DOC_NO: docNo
    })
  }
}
