import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from 'src/app/core/modal.service';
import { Globals } from '../../../core/global';


@Component({
  selector: 'snse039p',
  templateUrl: './SNSE039P.component.html',
  styleUrls: ['./SNSE039P.component.css']
})

export class SNSE039PComponent implements OnInit {

  constructor(
    private HttpService: HttpService,
    private modal: ModalService,
    private viewref: ViewContainerRef,
    private route: ActivatedRoute,
    private global: Globals
  ) { }

  //@ViewChild('fileUpload') myInputVariable: ElementRef;

  @Input() config: any;
  @Input() data: any;
  @Output() datacallback = new EventEmitter<string>();


  public dataListDialogInvoiceDate: any = [];
  public findingWord: string;

  public ConfigInvoiceDate: any = {
    ColName: "INVOICE_DATE",
    ColValue: "INVOICE_DATE",
    PlaceholderText: "Select Invoice Date in format[DD-MM-YYYY]",
    SourceController: "WH",
    SourceMethodName: "SNSE039P_InvoiceDate_Find",
    NoOfShowRecords: 100,
    MinLengthSearch: 1,
    UpperCase: true
  }

  public dataListSeqByInvoiceDate: any =[];

  public ListDataReportCondition: any = {
    INVOICE_DATE : null,//Step 1 
    INVOICE_SEQ : null,//Step 2
    BEGIN_INVOICE_NO : null,//Report used
    END_INVOICE_NO : null//Report used
  };

  ngOnInit() {
  }

  OpenReport(){
    if(this.CheckSearchCondition()){
      //console.log("Sent to Report:",this.ListDataReportCondition);
      //alert('Wait open report.' + this.ListDataReportCondition.BEGIN_INVOICE_NO +"-"+ this.ListDataReportCondition.BEGIN_INVOICE_NO);
      this.GoToReport();//show roport viewer.
    }
  }
  CheckSearchCondition():boolean{
    let boolHadSelectedCondition : boolean;
    boolHadSelectedCondition = false;//maening: User is not selecting condition search report.
    //define Emply string to Null, when call report, emply string will not sent to server report.
    
    if(!this.ListDataReportCondition.BEGIN_INVOICE_NO && !this.ListDataReportCondition.BEGIN_INVOICE_NO){
        boolHadSelectedCondition = false;
    }else{
        boolHadSelectedCondition = true;
    }

    return boolHadSelectedCondition;
  }//end CheckSearchCondition

  GoToReport() {
    console.log('Show list data report',this.ListDataReportCondition);
    this.global.GoToReport("PMS_RPT_WH_SNSE039", {  P_COMPANY_CODE: this.global.GetTokenDetail("ssComCode"), 
                                                    P_S_INVOICE_NO: this.ListDataReportCondition.BEGIN_INVOICE_NO, 
                                                    P_E_INVOICE_NO: this.ListDataReportCondition.END_INVOICE_NO
                                                  })
  }

  public FindSeqByInvoiceDate(strInvoiceDate:any){
      if (!!strInvoiceDate) {
        // console.log("Before data: ",this.dataListSeqByInvoiceDate);
        this.HttpService.get("WH", "SNSE039P_SEQ_BY_DATE", strInvoiceDate || "null")
        .subscribe(result => {

          this.dataListSeqByInvoiceDate = result.Table;
          //console.log("After data: ",this.dataListSeqByInvoiceDate);
          
          if(result.Table.length > 0 ){
            this.ListDataReportCondition.INVOICE_SEQ = this.dataListSeqByInvoiceDate[0].PICK_LOT_SEQ;
            this.ListDataReportCondition.BEGIN_INVOICE_NO = this.dataListSeqByInvoiceDate[0].MIN_INV;
            this.ListDataReportCondition.END_INVOICE_NO = this.dataListSeqByInvoiceDate[0].MAX_INV;
          }

        }, err => {
            this.modal.error(err.message, this.viewref);
        });

      } else {
        alert('Please input at less 3 characters');
      }
  }

  SeqSelectChange(value: any){
    // console.log("Show:",value);  
    this.dataListSeqByInvoiceDate.forEach(element => {
      if(element.PICK_LOT_SEQ == value){
        this.ListDataReportCondition.INVOICE_SEQ = element.PICK_LOT_SEQ;
        this.ListDataReportCondition.BEGIN_INVOICE_NO = element.MIN_INV;
        this.ListDataReportCondition.END_INVOICE_NO = element.MAX_INV;
        return;
      }
    });
  }

  //func dialog

  // onNoClick(){
    
  // }
  // public Find() {
  //     this.HttpService.get("System", "FindPO", this.findingWord.toUpperCase())
  //       .subscribe(result => {       
  //         this.dataListDialogInvoiceDate = result.Table;
  //       })
  // }

  //end func dialog

}
