import { Component, OnInit } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from '../../../core/modal.service';
import { Globals } from 'src/app/core/global';

@Component({
  selector: 'snse042NA4',
  templateUrl: './SNSE042NA4.component.html',
  styleUrls: ['./SNSE042NA4.component.css']
})


export class SNSE042NA4Component implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router,
    private route: ActivatedRoute,
    private modal: ModalService,
    private global: Globals
  ) { }
    ngOnInit() {
    }

  public PickLotDate: any;
  public PickLotSeq: any;
  public PickBeginInvoiceNo: any = {};
  public PickEndInvoiceNo: any = {};
  

  public params = {
    PICK_LOT_DATE: null,
    PICK_LOT_SEQ: null,
    BEGIN_INVOICE_NO: null,
    END_INVOICE_NO: null
  }

  


  public ConfigPickLotDate: any = {
    ColName: "PICK_LOT_DATE",
    PlaceholderText: "Select Pick lot date",
    SourceController: "SL",
    SourceMethodName: "SNSE042NA4_getPickLotDate",
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: true

  }
  public ConfigPickLotSeq: any = {
    ColName: "PICK_LOT_SEQ",
    PlaceholderText: "Select Pick Lot Seq",
    SourceController: "SL",
    SourceMethodName: "SNSE042NA4_getPickLotSeq", 
    NoOfShowRecords: 20,
    MinLengthSearch: 0,
    UpperCase: false

  }

  public PrintReport() {
    //this.global.GoToReport("PMS_RPT_IC_SNPP021", {
    //  P_PICK_LOT_DATE: this.PickLotDate.PICK_LOT_DATE,
    //  P_PICK_LOT_SEQ: this.PickLotSeq.PICK_LOT_SEQ,
    //  BEGIN_INVOICE_NO: this.PickBeginInvoiceNo.MIN_INV,
    //  END_INVOICE_NO: this.PickEndInvoiceNo.MAX_INV
    //})
  }

  
  public SetPickLotDate(values: any) {
    this.params.PICK_LOT_DATE = values.PICK_LOT_DATE;
  }
  public SetPickLotSeq(values: any) {
    this.params.PICK_LOT_SEQ = values.PICK_LOT_SEQ;
    this.params.BEGIN_INVOICE_NO = values.MIN_INV;
    this.params.END_INVOICE_NO = values.MAX_INV;

  }
  
 
}
