
import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef, Inject, SimpleChanges } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { FormControl } from '@angular/forms';
import * as moment from 'moment';

import { ModalService } from 'src/app/core/modal.service';
import { MatDialog, MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';

@Component({
  selector: 'SNSQ005_GPart',
  templateUrl: './SNSQ005_GPart.component.html',
  styleUrls: ['./../SNSQ005_001.component.css']
})

export class SNSQ005_GPartComponent implements OnInit {

  constructor(
    private http: HttpService,
    private router: Router,
    private modal: ModalService,
    public dialog: MatDialog,
    private viewRef: ViewContainerRef
  ) { }


  @Input() pPartNo: string;
  @Input() dataInfo: any = [];

  public dataGPart: any = [];
  public dataDom: any = [];
  public dataExport: any = [];
  public dataIndent: any = [];

  public dataListGPart: any = {};

  ngOnInit() {
    this.GetData();
  }


  ngOnChanges(changes: SimpleChanges): void {
    if (!changes["pPartNo"].isFirstChange()) {
      this.GetData();
    }
  }

  private GetData() {
    this.dataGPart.OH_QTY = 0;
    this.dataGPart.PO_QTY = 0;
    this.dataGPart.BO_QTY = 0;
    if (this.pPartNo.length >= 3) {
      this.http.get("IC", "SNSQ005_GetGroupPartInfo", this.pPartNo)
        .subscribe(result => {
          this.dataGPart = result.Table[0];

          if (result.Table1[0] == undefined) {
            this.dataDom.ORDER_QTY_N_01 = 0;
            this.dataDom.ORDER_QTY_N_02 = 0;
            this.dataDom.ORDER_QTY_N_03 = 0;
            this.dataDom.ORDER_QTY_N_04 = 0;
            this.dataDom.ORDER_QTY_N_05 = 0;
            this.dataDom.ORDER_QTY_N_06 = 0;
            this.dataDom.ORDER_QTY_N_07 = 0;
            this.dataDom.ORDER_QTY_N_08 = 0;
            this.dataDom.ORDER_QTY_N_09 = 0;
            this.dataDom.ORDER_QTY_N_10 = 0;
            this.dataDom.ORDER_QTY_N_11 = 0;
            this.dataDom.ORDER_QTY_N_12 = 0;
          } else {
            this.dataDom = result.Table1[0];
          }
         
          if (result.Table2[0] == undefined) {
            this.dataExport.ORDER_QTY_N_01 = 0;
            this.dataExport.ORDER_QTY_N_02 = 0;
            this.dataExport.ORDER_QTY_N_03 = 0;
            this.dataExport.ORDER_QTY_N_04 = 0;
            this.dataExport.ORDER_QTY_N_05 = 0;
            this.dataExport.ORDER_QTY_N_06 = 0;
            this.dataExport.ORDER_QTY_N_07 = 0;
            this.dataExport.ORDER_QTY_N_08 = 0;
            this.dataExport.ORDER_QTY_N_09 = 0;
            this.dataExport.ORDER_QTY_N_10 = 0;
            this.dataExport.ORDER_QTY_N_11 = 0;
            this.dataExport.ORDER_QTY_N_12 = 0;
          } else {
            this.dataExport = result.Table2[0];
          }

          if (result.Table3[0] == undefined) {
            this.dataIndent.ORDER_QTY_N_01 = 0;
            this.dataIndent.ORDER_QTY_N_02 = 0;
            this.dataIndent.ORDER_QTY_N_03 = 0;
            this.dataIndent.ORDER_QTY_N_04 = 0;
            this.dataIndent.ORDER_QTY_N_05 = 0;
            this.dataIndent.ORDER_QTY_N_06 = 0;
            this.dataIndent.ORDER_QTY_N_07 = 0;
            this.dataIndent.ORDER_QTY_N_08 = 0;
            this.dataIndent.ORDER_QTY_N_09 = 0;
            this.dataIndent.ORDER_QTY_N_10 = 0;
            this.dataIndent.ORDER_QTY_N_11 = 0;
            this.dataIndent.ORDER_QTY_N_12 = 0;
          } else {
            this.dataIndent = result.Table3[0];
          }
        })
    } else {

    }

  }

}
