import { Component, OnInit, Input, Output, EventEmitter, TemplateRef, ContentChild, ViewChild, ViewContainerRef } from '@angular/core';
import { HttpService } from 'src/app/core/http.service';
import { Router, ActivatedRoute } from '@angular/router';
import { ModalService } from '../../../core/modal.service';

@Component({
  selector: 'snsq048_001',
  templateUrl: './snsq048_001.component.html',
  styleUrls: ['./snsq048_001.component.css']
})



export class SNSQ048_001Component implements OnInit {


  constructor(
    private http: HttpService,
    private router: Router,
    private route: ActivatedRoute,
    private modal: ModalService,
    private viewref: ViewContainerRef
  ) { }

  public tabledata: any = [];
  public PROCESS_LOG: any = []

  public params: any = {
    FROM_DATE: null,
    TO_DATE: null,
    PART_NUMBER: null
  }

  public ConfigPartNumber: any = {
    ColName: "LOOKUP_PART_NUMBER",
    PlaceholderText: "Select Part No",
    SourceController: "SL",
    SourceMethodName: "SNSQ048_getPartNo",
    NoOfShowRecords: 50,
    MinLengthSearch: 0,
    UpperCase: true
  }

  public SetPartNumber(values: any) {
    this.params.PART_NUMBER  = values.PART_NUMBER
  }

  public Search() {
    this.tabledata = [];
    this.http.post("SL", "SNSQ048_getSearch", this.params)
      .subscribe(res => {
        this.tabledata = res.Table;
      })
  }


  public ExportExcel() {
    this.http.Download("SL", "SNSQ048_Export_Excel", JSON.stringify(this.tabledata))
      .subscribe(res => {
        if (res) {
          this.WriteContents(res)
          this.PROCESS_LOG.push('Export complete ' + this.tabledata.length + ' records.');
        } else {
          this.modal.error('Download not complete', this.viewref)
        }
      })
  }

  public WriteContents(content) {
    const a = document.createElement('a');
    const file = new Blob([content], { type: content.type });
    var date_export = new Date();
    a.href = URL.createObjectURL(file);
    a.download = "SNSQ048" + "_" + date_export.getFullYear() + "/" + (date_export.getMonth() + 1) + "/" + date_export.getDate() + ".csv";
    a.click();
  }

  ngOnInit() {
  }

}

