import { Component, OnInit } from "@angular/core";
import { HttpService } from 'src/app/core/http.service';
import { Router } from '@angular/router';
import { Globals } from 'src/app/core/global';

@Component({
    selector: 'snse184',
    templateUrl: './snse184.component.html',
    styleUrls: ['./snse184.component.css']
})

export class SNSE184Component implements OnInit {
    constructor(
        private http: HttpService,
        private router: Router,
        private global : Globals
    ) { }

    public data: any = [];
    public data_log: any = [];
    public tabIndex : number = 0;
    public opened1: boolean;
    public opened2: boolean;

    public ConfigPart: any = {
        ColName: "LOOKUP_PART_NAME",
        ColValue: "PART_NO",
        PlaceholderText: "Select Part No.",
        SourceController: "wPMS",
        SourceMethodName: "GetPartNo",
        NoOfShowRecords: 50,
        MinLengthSearch: 5
      }

      public ConfigLocation: any = {
        ColName: "LOCATION_NO",
        ColValue: "LOCATION_NO",
        PlaceholderText: "Select Location.",
        SourceController: "WH",
        SourceMethodName: "GetLocation",
        NoOfShowRecords: 50,
        MinLengthSearch: 2,
        UpperCase: true
      }


      public ConfigNewLocation: any = {
        ColName: "NEW_LOCATION",
        ColValue: "NEW_LOCATION",
        PlaceholderText: "Select NewLocation.",
        SourceController: "WH",
        SourceMethodName: "GetNewLocation",
        NoOfShowRecords: 50,
        MinLengthSearch: 2,
        UpperCase: true
      }

      
      public ConfigPrintDate: any = {
        ColName: "PRINT_CODE",
        ColValue: "PRINT_CODE",
        PlaceholderText: "Select PrintDate.",
        SourceController: "WH",
        SourceMethodName: "GetPrintCode",
        NoOfShowRecords: 50,
        MinLengthSearch: 2,
        UpperCase: true
      }

    public params = {
        CURRENT_LOCATION_FROM : null,
        CURRENT_LOCATION_TO : null,
        PART_FROM : null,
        PART_TO : null,
        NEW_LOCATION_FROM : null,
        NEW_LOCATION_TO : null,
        PRINT_DATE_FROM : null,
        PRINT_DATE_TO : null,
        STATUS_NO : 'ALL',
        UPDATE_FLAG : 'ALL'
    }

    public StatusList = [
                         {NAME : 'ALL',ID : 'ALL'},
                         {NAME : '1 = Print Relocation Card',ID : '1'},
                         {NAME : '2 = Pick/Pack',ID : '2'},
                         {NAME : '3 = Shelve',ID : '3'},
                         {NAME : '4 = Relocation Complete',ID : '4'}
                        ]

    public UpdFlagList = [
                        {NAME : 'ALL',ID : 'ALL'},
                        {NAME : 'Y = Updated New Location',ID : 'Y'},
                        {NAME : 'N = Not Update New Location',ID : 'N'}
                        ]

    ngOnInit() {


    }


    GetData(){
        this.data = []

        this.http.post("WH","SNSE184_GetData",this.params)
        .subscribe(res =>{
            console.log(res)
            this.data = res.Table
        })
    }


    GetDataLog(param){
        this.http.post("WH","SNSE184_GetDataLog",param)
        .subscribe(res => {
            this.data_log = res.Table;
        })
    }

    Export(){
        this.http.Download("WH","SNSE184_Export",this.data)
        .subscribe(res =>{
            this.writeContents(res)
        })
    }

    writeContents(content) {
        const a = document.createElement('a');
        const file = new Blob([content], { type: content.type });
        a.href = URL.createObjectURL(file);
        a.download = "SNSE184" + '_' + this.global.CurrentDate() + ".csv";
        a.click();
      }

    SelectRow(event){
    this.GetDataLog(event);
    }

    tabChanged(event){
        this.tabIndex = event.index
    }

    ClearData(){
         
            this.params.CURRENT_LOCATION_FROM = null
            this.params.CURRENT_LOCATION_TO = null
            this.params.PART_FROM= null
            this.params.PART_TO = null
            this.params.NEW_LOCATION_FROM= null
            this.params.NEW_LOCATION_TO = null
            this.params.PRINT_DATE_FROM = null
            this.params.PRINT_DATE_TO = null
            this.params.STATUS_NO = 'ALL'
            this.params.UPDATE_FLAG = 'ALL'
            this.data = [];
    }
}
